## mysql-workbench 5.2.38+dfsg

=== ext/cppconn/CMakeLists.txt ===
#
# Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
#
# The MySQL Connector/C++ is licensed under the terms of the GPLv2
# <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>, like most
# MySQL Connectors. There are special exceptions to the terms and
# conditions of the GPLv2 as it is applied to this software, see the
# FLOSS License Exception
# <http://www.mysql.com/about/legal/licensing/foss-exception.html>.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
#


PROJECT(MYSQLCPPCONN)

# Bump this every time we change the API/ABI
SET(MYSQLCPPCONN_SOVERSION "6")


IF(WIN32)
# We need this for mysqlcppconn_EXPORTS needed for the static build
	cmake_minimum_required(VERSION 2.6.2)
ELSE(WIN32)
	cmake_minimum_required(VERSION 2.6)
ENDIF(WIN32)

#-----------------
# CPPFLAGS, CXXFLAGS and LDFLAGS from the environment
SET(MYSQLCPPCONN_COMPILE_FLAGS_ENV "$ENV{CPPFLAGS} ${MYSQL_CXXFLAGS} $ENV{CXXFLAGS}")
MESSAGE(STATUS "Environment compile flags: ${MYSQLCPPCONN_COMPILE_FLAGS_ENV}")

SET(MYSQLCPPCONN_LINK_FLAGS_ENV "$ENV{LDFLAGS}")
MESSAGE(STATUS "Environment link flags: ${MYSQLCPPCONN_LINK_FLAGS_ENV}")

#-----------------
# ICU

SET(MYSQLCPPCONN_ICU_ENABLE 0 CACHE BOOL "development only: search icu although we do not make use of it yet.")

IF(MYSQLCPPCONN_ICU_ENABLE)
	SET(MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE)
	SET(MYSQLCPPCONN_ICU_LIBRARY)
	SET(MYSQLCPPCONN_ICU_INCLUDE)

	FIND_PROGRAM (MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE icu-config)

	IF (NOT MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE)
		SET (MYSQLCPPCONN_ICU_FOUND FALSE)
			MESSAGE(STATUS "icu-config not found")
	ELSE (NOT MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE)

		EXEC_PROGRAM ("${MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE} --ldflags-libsonly"
		OUTPUT_VARIABLE MYSQLCPPCONN_ICU_LIBRARY
		RETURN_VALUE ERROR_CODE
		)

		EXEC_PROGRAM ("${MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE} --cppflags-searchpath|sed s/^-I//"
		OUTPUT_VARIABLE MYSQLCPPCONN_ICU_INCLUDE
		RETURN_VALUE ERROR_CODE
		)

		EXEC_PROGRAM ("${MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE} --ldflags-searchpath|sed s/^-L//"
		OUTPUT_VARIABLE MYSQLCPPCONN_ICU_LDLIB
		RETURN_VALUE ERROR_CODE
		)

		IF (MYSQLCPPCONN_ICU_LIBRARY)
			SET (MYSQLCPPCONN_ICU_FOUND TRUE)
		ENDIF (MYSQLCPPCONN_ICU_LIBRARY)

		MESSAGE(STATUS "ICU::CONFIG: ${MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE}")
		MESSAGE(STATUS "ICU::LIBRARY: ${MYSQLCPPCONN_ICU_LIBRARY}")
		MESSAGE(STATUS "ICU::INCLUDE: ${MYSQLCPPCONN_ICU_INCLUDE}")
		MESSAGE(STATUS "ICU::LDLIB: ${MYSQLCPPCONN_ICU_LDLIB}")

		INCLUDE_DIRECTORIES(${MYSQLCPPCONN_ICU_INCLUDE})
		LINK_DIRECTORIES(${MYSQLCPPCONN_ICU_LDLIB})
	ENDIF (NOT MYSQLCPPCONN_ICU_CONFIG_EXECUTABLE)
ENDIF(MYSQLCPPCONN_ICU_ENABLE)
#-----------------

#-----------------
# BOOST
SET(ENV_BOOST $ENV{BOOST_ROOT})
IF(NOT BOOST_ROOT AND ENV_BOOST)
	SET(BOOST_ROOT ${ENV_BOOST})
ENDIF(NOT BOOST_ROOT AND ENV_BOOST)

IF(NOT BOOST_ROOT AND WIN32)
        SET(BOOST_ROOT "C:/Program Files/Boost")
ENDIF(NOT BOOST_ROOT AND WIN32)

# Prefer static linking in all cases
SET(Boost_ADDITIONAL_VERSIONS "1.37.0" "1.37" "1.38.0" "1.38" "1.39.0" "1.39")
SET(MYSQLCPPCONN_BOOST_COMPONENTS thread date_time)
SET(Boost_USE_STATIC_LIBS TRUE)
#FIND_PACKAGE(Boost COMPONENTS ${MYSQLCPPCONN_BOOST_COMPONENTS})
FIND_PACKAGE(Boost)
IF(NOT Boost_FOUND)
	# Try dynamic
	set(Boost_USE_STATIC_LIBS FALSE)
	FIND_PACKAGE(Boost COMPONENTS ${MYSQLCPPCONN_BOOST_COMPONENTS})
	IF(NOT Boost_FOUND)
		MESSAGE(FATAL_ERROR "Boost or some of its libraries found. If not in standard place please set -DBOOST_ROOT:STRING=")
	ENDIF(NOT Boost_FOUND)
ENDIF(NOT Boost_FOUND)

SET(MYSQLCPPCONN_BOOST_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
SET(MYSQLCPPCONN_BOOST_SYSTEM_LIBS ${Boost_SYSTEM_LIBRARY})
SET(MYSQLCPPCONN_BOOST_THREAD_LIBS ${Boost_THREAD_LIBRARY})
SET(MYSQLCPPCONN_BOOST_LIBRARY_DIRS ${Boost_LIBRARY_DIRS})

INCLUDE_DIRECTORIES(${MYSQLCPPCONN_BOOST_INCLUDE_DIRS})
MESSAGE(STATUS "BOOST_INCLUDE_DIRS=${MYSQLCPPCONN_BOOST_INCLUDE_DIRS}")


#-----------------


if(COMMAND cmake_policy)
        cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckTypeSize)


#----------------------
# STLPORT - BEGIN
#
SET(MYSQLCPPCONN_STLPORT_ENABLE 0 CACHE BOOL "stlport-enabled")
IF(MYSQLCPPCONN_STLPORT_ENABLE)
	MESSAGE(STATUS "Looking for STLPort")
	FIND_PATH(STLPORT_INCLUDE_DIR stl_user_config.h
			$ENV{STLPORT_INCLUDE_DIR}
			/usr/include/stlport
			/usr/local/include/stlport)
	IF(STLPORT_INCLUDE_DIR)
		MESSAGE(STATUS "Using STLPort from : ${STLPORT_INCLUDE_DIR}")

		INCLUDE_DIRECTORIES(STLPORT_INCLUDE_DIR)
		SET(MYSQLCPPCONN_STLPORT_LIB "stlport")
	ELSE(STLPORT_INCLUDE_DIR)
		MESSAGE(FATAL_ERROR "STLPORT not found. Please set \$ENV{STLPORT_INCLUDE_DIR} if installed in non-standard location")
	ENDIF(STLPORT_INCLUDE_DIR)
ELSE(MYSQLCPPCONN_STLPORT_ENABLE)
	SET(MYSQLCPPCONN_STLPORT_LIB "")
ENDIF(MYSQLCPPCONN_STLPORT_ENABLE)
#
# STLPORT - END
#----------------------

# Make tests cover methods that throw not implemented to detect API changes?
SET(MYSQLCPPCONN_TEST_NOT_IMPLEMENTED 0 CACHE BOOL "HEAD/trunk QA: invoke methods that should return not implemented to detect API changes")

INCLUDE(${CMAKE_SOURCE_DIR}/FindMySQL.cm)

# ----------------------------------------------------------------------
# Create package script
# ----------------------------------------------------------------------

IF(NOT CONNECTOR_PLATFORM)
  IF(WIN32)
    IF(CMAKE_SIZEOF_VOID_P MATCHES 8)
      SET(CONNECTOR_PLATFORM "winx64")
    ELSE(CMAKE_SIZEOF_VOID_P MATCHES 8)
      SET(CONNECTOR_PLATFORM "win32")
    ENDIF(CMAKE_SIZEOF_VOID_P MATCHES 8)
  ELSE(WIN32)
    SET(CONNECTOR_PLATFORM "unknown")
  ENDIF(WIN32)
ENDIF(NOT CONNECTOR_PLATFORM)

# Get the part of the package name for this product
IF(MYSQL_SERVER_SUFFIX STREQUAL "-community")
  SET(CPACK_SERVER_SUFFIX "")
ELSE(MYSQL_SERVER_SUFFIX STREQUAL "-community")
  SET(CPACK_SERVER_SUFFIX ${MYSQL_SERVER_SUFFIX})
ENDIF(MYSQL_SERVER_SUFFIX STREQUAL "-community")

IF(EXTRA_NAME_SUFFIX)
  SET(CPACK_PACKAGE_NAME "mysql-connector-c++${EXTRA_NAME_SUFFIX}")
ELSE(EXTRA_NAME_SUFFIX)
  SET(CPACK_PACKAGE_NAME "mysql-connector-c++")
ENDIF(EXTRA_NAME_SUFFIX)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY
    "Connector/C++, a library for connecting to MySQL servers.")
SET(CPACK_PACKAGE_VERSION_MAJOR 1)
SET(CPACK_PACKAGE_VERSION_MINOR 1)
SET(CPACK_PACKAGE_VERSION_PATCH 1)
SET(CPACK_PACKAGE_RELEASE_TYPE "")
SET(CPACK_PACKAGE_VENDOR "Oracle and/or its affiliates")
SET(CPACK_RPM_PACKAGE_DESCRIPTION
"The MySQL Connector/C++ is a MySQL database connector for C++. The
MySQL Driver for C++ can be used to connect to the MySQL Server from
C++ applications. The MySQL Driver for C++ mimics the JDBC 4.0 API. It
is recommended to use the connector with MySQL 5.1 or later. Note -
its full functionality is not available when connecting to MySQL 5.0.
The MySQL Driver for C++ cannot connect to MySQL 4.1 or earlier. MySQL
is a trademark of ${CPACK_PACKAGE_VENDOR}

The MySQL software has Dual Licensing, which means you can use the MySQL
software free of charge under the GNU General Public License
(http://www.gnu.org/licenses/). You can also purchase commercial MySQL
licenses from ${CPACK_PACKAGE_VENDOR} if you do not wish to be
bound by the terms of the GPL. See the chapter "Licensing and Support"
in the manual for further info.")

IF(EXISTS "${CMAKE_SOURCE_DIR}/COPYING")
  SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
ELSE(EXISTS "${CMAKE_SOURCE_DIR}/COPYING")
  SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.mysql")
ENDIF(EXISTS "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
SET(MYSQLCPPCONN_NUMERIC_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
IF(EXTRA_VERSION)
  SET(MYSQLCPPCONN_VERSION "${MYSQLCPPCONN_NUMERIC_VERSION}${EXTRA_VERSION}${CPACK_PACKAGE_RELEASE_TYPE}")
ELSE(EXTRA_VERSION)
  SET(MYSQLCPPCONN_VERSION "${MYSQLCPPCONN_NUMERIC_VERSION}${CPACK_PACKAGE_RELEASE_TYPE}")
ENDIF(EXTRA_VERSION)
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${MYSQLCPPCONN_VERSION}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}-${MYSQLCPPCONN_VERSION}-${CONNECTOR_PLATFORM}")
IF(WIN32)
  SET(CPACK_GENERATOR "ZIP")
  SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-noinstall-${MYSQLCPPCONN_VERSION}-${CONNECTOR_PLATFORM}")
ELSE(WIN32)
  SET(CPACK_GENERATOR "TGZ")
  SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY}")
ENDIF(WIN32)

IF(WIN32)
  FILE(WRITE "${CMAKE_SOURCE_DIR}/win/config.cmake" "SET(CONNECTOR_PRODUCT_VERSION ${MYSQLCPPCONN_VERSION})
SET( LICENSE_FILENAME "${CPACK_RESOURCE_FILE_LICENSE}")")
ENDIF(WIN32)

INSTALL(FILES ${CPACK_RESOURCE_FILE_README} ${CPACK_RESOURCE_FILE_INSTALL} ${CPACK_RESOURCE_FILE_LICENSE} "${CMAKE_SOURCE_DIR}/ANNOUNCEMENT" DESTINATION "." OPTIONAL)

SET(COMMON_IGNORE_FILES "/CMakeFiles/" "/Testing/" "/.bzr/" "_CPack_Packages/"
    ".cmake$" "~" ".swp" ".log" ".gz" ".directory$" "CMakeCache.txt" "Makefile"
	"install_manifest.txt")
SET(PRJ_COMMON_IGNORE_FILES ${COMMON_IGNORE_FILES} "ANNOUNCEMENT_102_ALPHA" "ANNOUNCEMENT_103_ALPHA" "ANNOUNCEMENT_104_BETA" "ANNOUNCEMENT_105_GA" "ANNOUNCEMENT_110_GA" "ANNOUNCEMENT_111_GA" "ANNOUNCEMENT_DRAFT" )

SET(CPACK_SOURCE_IGNORE_FILES ${PRJ_COMMON_IGNORE_FILES}  "./cppconn/config.h$" "./driver/nativeapi/binding_config.h$")
SET(CPACK_PACKAGE_IGNORE_FILES ${PRJ_COMMON_IGNORE_FILES} "something_there" )
SET(CPACK_SOURCE_GENERATOR "TGZ")

SET(MYSQLCPPCONN_GCOV_ENABLE 0 CACHE BOOL "gcov-enabled")
IF(CMAKE_COMPILER_IS_GNUCC)
	ADD_DEFINITIONS("-Wall -fPIC -Woverloaded-virtual")
	IF (MYSQLCPPCONN_GCOV_ENABLE)
		ADD_DEFINITIONS("-fprofile-arcs -ftest-coverage")
	ENDIF (MYSQLCPPCONN_GCOV_ENABLE)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

# SET(CPACK_*) before the INCLUDE(CPack)
INCLUDE(CPack)

IF(WIN32)
	STRING(REGEX REPLACE "MYSQLCPPCONN" "MySQL/ConnectorCPP" CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
ENDIF(WIN32)
MESSAGE(STATUS "Installation path is: ${CMAKE_INSTALL_PREFIX}   (overwrite with -DCMAKE_INSTALL_PREFIX=/your/path)")

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/cppconn)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/driver/nativeapi)

ADD_SUBDIRECTORY(cppconn)
ADD_SUBDIRECTORY(driver)
ADD_SUBDIRECTORY(examples)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(test/framework)
ADD_SUBDIRECTORY(test/CJUnitTestsPort)
ADD_SUBDIRECTORY(test/unit)

IF(DEFINED CMAKE_SYSTEM_NAME AND ${CMAKE_SYSTEM_NAME} STREQUAL "SunOS")
	# see also README
	IF(${CMAKE_C_COMPILER} MATCHES "gcc$")
		message("NOTE")
		message("You seem to be using GCC on SunOS.")
		message("This is not recommended. Compilation")
		message("might fail due to compile flags")
		message("returned by the MySQL tool mysql_config.")
		message("In case of an error, try commenting out:")
		message("# ADD_DEFINITIONS(\"\${MYSQL_CXXFLAGS}\")")
		message("in the file FindMySQL.cm")
	ENDIF(${CMAKE_C_COMPILER} MATCHES "gcc$")

	IF(${CMAKE_C_COMPILER} MATCHES "gcc$")
		IF(${CMAKE_CXX_COMPILER} MATCHES "CC$")
			message("NOTE")
			message("You seem to be using the GCC C-compiler")
			message("together with the Sun CC C++-compiler.")
			message("Linking of the resulting binaries")
			message("might fail. In case of an error,")
			message("try using Sun compilers only")

=== ext/cppconn/driver/CMakeLists.txt ===
#
# Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
#
# The MySQL Connector/C++ is licensed under the terms of the GPLv2
# <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>, like most
# MySQL Connectors. There are special exceptions to the terms and
# conditions of the GPLv2 as it is applied to this software, see the
# FLOSS License Exception
# <http://www.mysql.com/about/legal/licensing/foss-exception.html>.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
#


LINK_DIRECTORIES(${MYSQLCPPCONN_BOOST_LIBRARY_DIRS})


INCLUDE_DIRECTORIES(${MYSQLCPPCONN_SOURCE_DIR})
INCLUDE_DIRECTORIES(${MYSQLCPPCONN_SOURCE_DIR}/cppconn)
INCLUDE_DIRECTORIES(${MYSQLCPPCONN_BOOST_INCLUDE_DIRS})
MESSAGE(STATUS "BOOST_INCLUDE_DIRS=${MYSQLCPPCONN_BOOST_INCLUDE_DIRS}")


SET(MYSQLCPPCONN_TRACE_ENABLE 0 CACHE BOOL "trace-enabled")

IF(MYSQLCPPCONN_TRACE_ENABLE)
	MESSAGE(STATUS "Building with tracing functionality")
	# Visual Studio 8 and up understand Variadic macros
	IF(WIN32)
		IF(CMAKE_GENERATOR MATCHES "Visual Studio 8"
			OR CMAKE_GENERATOR MATCHES "Visual Studio 9"
			OR CMAKE_GENERATOR MATCHES "NMake Makefiles")

			ADD_DEFINITIONS("-DCPPCONN_TRACE_ENABLED")
		ELSE(CMAKE_GENERATOR MATCHES "Visual Studio 8"
				OR CMAKE_GENERATOR MATCHES "Visual Studio 9"
				OR CMAKE_GENERATOR MATCHES "NMake Makefiles")
			MESSAGE(STATUS "Tracing will not be available in this build. VC8 or VC9 is needed.")
		ENDIF(CMAKE_GENERATOR MATCHES "Visual Studio 8"
				OR CMAKE_GENERATOR MATCHES "Visual Studio 9"
				OR CMAKE_GENERATOR MATCHES "NMake Makefiles")
	ELSE(WIN32)
		ADD_DEFINITIONS("-DCPPCONN_TRACE_ENABLED")
	ENDIF(WIN32)
ENDIF(MYSQLCPPCONN_TRACE_ENABLE)

SET(MYSQLCLIENT_STATIC_BINDING 1 CACHE BOOL "enable static binding")

IF(MYSQLCLIENT_STATIC_BINDING)
	MESSAGE(STATUS "Using static libmysql binding")
ELSE(MYSQLCLIENT_STATIC_BINDING)
	MESSAGE(STATUS "Using dynamic libmysql binding")
ENDIF(MYSQLCLIENT_STATIC_BINDING)

IF(NOT MYSQLCLIENT_STATIC_BINDING)
	IF(NOT WIN32)
		CHECK_INCLUDE_FILES(dlfcn.h HAVE_DLFCN_H)
		# We are not on windows and don't have dlfcn.h - so we need static binding
		IF(NOT HAVE_DLFCN_H)
                        MESSAGE(FATAL_ERROR "Dynamic binding has been requested but we cannot find dlfcn.h!")
			SET(MYSQLCLIENT_STATIC_BINDING 1)
		ENDIF(NOT HAVE_DLFCN_H)
	ENDIF(NOT WIN32)
ENDIF(NOT MYSQLCLIENT_STATIC_BINDING)

#-----------------
# CPPFLAGS, CXXFLAGS and LDFLAGS from the environment
SET(MYSQLCPPCONN_DT_RPATH "" CACHE STRING "For dynamic libmysql binding: DT_RPATH to set (default: unset)")

IF(MYSQLCPPCONN_DT_RPATH)
	SET(CMAKE_SKIP_BUILD_RPATH  TRUE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
	SET(CMAKE_INSTALL_RPATH ${MYSQLCPPCONN_DT_RPATH})
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

	MESSAGE(STATUS "DT_RPATH set to ${CMAKE_INSTALL_RPATH}")

ELSE(MYSQLCPPCONN_DT_RPATH)
	SET(CMAKE_SKIP_RPATH TRUE)

	MESSAGE(STATUS "DT_RPATH will not be set")

ENDIF(MYSQLCPPCONN_DT_RPATH)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/nativeapi/binding_config.h.cm ${CMAKE_CURRENT_BINARY_DIR}/nativeapi/binding_config.h)

SET(MYSQLCPPCONN_SOURCES
	mysql_art_resultset.cpp
	mysql_art_rset_metadata.cpp
	mysql_connection.cpp
	mysql_debug.cpp
	mysql_driver.cpp
	mysql_metadata.cpp
	mysql_parameter_metadata.cpp
	mysql_prepared_statement.cpp
	mysql_ps_resultset.cpp
	mysql_ps_resultset_metadata.cpp
	mysql_resultbind.cpp
	mysql_resultset.cpp
	mysql_resultset_metadata.cpp
	mysql_statement.cpp
	mysql_util.cpp
	mysql_warning.cpp
	nativeapi/mysql_client_api.cpp
	nativeapi/library_loader.cpp
	nativeapi/mysql_native_driver_wrapper.cpp
	nativeapi/mysql_native_connection_wrapper.cpp
	nativeapi/mysql_native_statement_wrapper.cpp
	nativeapi/mysql_native_resultset_wrapper.cpp
)


IF(WIN32)
	# adding headers to sources, so they will be included to VS projects

	SET(MYSQLCPPCONN_SOURCES
		${MYSQLCPPCONN_SOURCES}
		mysql_art_resultset.h
		mysql_art_rset_metadata.h
		mysql_connection.h
		mysql_debug.h
		mysql_driver.h
		mysql_metadata.h
		mysql_parameter_metadata.h
		mysql_prepared_statement.h
		mysql_ps_resultset.h
		mysql_ps_resultset_metadata.h
		mysql_resultbind.h
		mysql_resultset.h
		mysql_resultset_metadata.h
		mysql_statement.h
		mysql_util.h
		mysql_warning.h
		nativeapi/mysql_client_api.h
		nativeapi/mysql_native_driver_wrapper.h
		nativeapi/native_driver_wrapper.h
		nativeapi/mysql_native_connection_wrapper.h
		nativeapi/native_connection_wrapper.h
		nativeapi/mysql_native_statement_wrapper.h
		nativeapi/native_statement_wrapper.h
		nativeapi/mysql_native_resultset_wrapper.h
		nativeapi/native_resultset_wrapper.h
		../cppconn/warning.h
		../cppconn/statement.h
		../cppconn/sqlstring.h
		../cppconn/resultset_metadata.h
		../cppconn/resultset.h
		../cppconn/prepared_statement.h
		../cppconn/parameter_metadata.h
		../cppconn/metadata.h
		../cppconn/exception.h
		../cppconn/driver.h
		../cppconn/datatype.h
		../cppconn/connection.h
		../cppconn/config.h
		../cppconn/build_config.h

	)

	IF(NOT MYSQLCLIENT_STATIC_BINDING)
		SET(MYSQLCPPCONN_SOURCES ${MYSQLCPPCONN_SOURCES}
									nativeapi/library_loader.h)
	ENDIF(NOT MYSQLCLIENT_STATIC_BINDING)

	# Used to create source filter in projects in VS
	SOURCE_GROUP(NativeApi nativeapi/.+)
	SOURCE_GROUP(API ../cppconn/.+)
ENDIF(WIN32)


ADD_LIBRARY(mysqlcppconn SHARED ${MYSQLCPPCONN_SOURCES})
ADD_LIBRARY(mysqlcppconn-static STATIC ${MYSQLCPPCONN_SOURCES})

IF(WIN32)

	INCLUDE_DIRECTORIES(${MYSQL_DIR}/include)
	IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
		LINK_DIRECTORIES(${MYSQL_DIR}/lib/debug)
	ELSEIF(CMAKE_BUILD_TYPE STREQUAL "")
		LINK_DIRECTORIES(${MYSQL_DIR}/lib/opt)
	ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

	SET(MYSQLCPPCONN_SOURCES ${MYSQLCPPCONN_SOURCES} mysqlcppconn.def)


	ADD_DEFINITIONS("-D_CRT_SECURE_NO_WARNINGS")


	#Disables bunch of pretty useless warnings on win
	ADD_DEFINITIONS("-D_SCL_SECURE_NO_WARNINGS")

	IF(MYSQLCLIENT_STATIC_BINDING)
		SET(MY_TARGET_LINK_LIBRARIES_DYNAMIC libmysql ws2_32)
	ELSE(MYSQLCLIENT_STATIC_BINDING)
		SET(MY_TARGET_LINK_LIBRARIES_DYNAMIC ws2_32)
	ENDIF(MYSQLCLIENT_STATIC_BINDING)

	SET(MY_TARGET_LINK_LIBRARIES_STATIC mysqlclient ws2_32)
ELSEIF(NOT WIN32)

	IF(MYSQLCLIENT_STATIC_BINDING)
	  SET(MY_TARGET_LINK_LIBRARIES_DYNAMIC ${MYSQL_LIBRARIES} ${MYSQL_LINK_FLAGS})
		SET(MY_TARGET_LINK_LIBRARIES_STATIC ${MYSQL_LIBRARIES} ${MYSQL_LINK_FLAGS})
	ELSE(MYSQLCLIENT_STATIC_BINDING)
		FOREACH(_lib ${MYSQL_LIBRARIES})
			IF(NOT _lib MATCHES "libmysqlclient.*" AND NOT _lib MATCHES "mysqlclient.*")
				SET(MY_TARGET_LINK_LIBRARIES_DYNAMIC ${MY_TARGET_LINK_LIBRARIES_DYNAMIC} ${_lib})
				SET(MY_TARGET_LINK_LIBRARIES_STATIC ${MY_TARGET_LINK_LIBRARIES_STATIC} ${_lib})
			ENDIF(NOT _lib MATCHES "libmysqlclient.*" AND NOT _lib MATCHES "mysqlclient.*")
		ENDFOREACH(_lib ${MYSQL_LIBRARIES})
		SET(MY_TARGET_LINK_LIBRARIES_DYNAMIC ${MY_TARGET_LINK_LIBRARIES_DYNAMIC} ${MYSQL_LINK_FLAGS} ${CMAKE_DL_LIBS})
		SET(MY_TARGET_LINK_LIBRARIES_STATIC ${MY_TARGET_LINK_LIBRARIES_STATIC} ${MYSQL_LINK_FLAGS} ${CMAKE_DL_LIBS})
	ENDIF(MYSQLCLIENT_STATIC_BINDING)
ENDIF(WIN32)


IF(CMAKE_COMPILER_IS_GNUCC AND MYSQLCPPCONN_GCOV_ENABLE)
	SET(MY_GCOV_LINK_LIBRARIES gcov)
ENDIF(CMAKE_COMPILER_IS_GNUCC AND MYSQLCPPCONN_GCOV_ENABLE)


TARGET_LINK_LIBRARIES(mysqlcppconn	${MY_TARGET_LINK_LIBRARIES_DYNAMIC}
									${MY_GCOV_LINK_LIBRARIES}
									${MYSQLCPPCONN_STLPORT_LIB}
									${MYSQLCPPCONN_BOOST_SYSTEM_LIBS}
									${MYSQLCPPCONN_BOOST_THREAD_LIBS}
									${MYSQLCPPCONN_ICU_LIBRARY})

# Need to find way it's defined for mysqlcppconn-static only
#IF(WIN32)
#	ADD_DEFINITIONS("-DCPPCONN_PUBLIC_FUNC=\"\"")
#ENDIF(WIN32)


TARGET_LINK_LIBRARIES(mysqlcppconn-static	${MY_TARGET_LINK_LIBRARIES_STATIC}
											${MY_GCOV_LINK_LIBRARIES}
											${MYSQLCPPCONN_STLPORT_LIB}
											${MYSQLCPPCONN_BOOST_SYSTEM_LIBS}
											${MYSQLCPPCONN_BOOST_THREAD_LIBS}
											${MYSQLCPPCONN_ICU_LIBRARY})

MESSAGE("$ENV{CPPFLAGS} ${MYSQL_CXXFLAGS} $ENV{CXXFLAGS}")

SET_TARGET_PROPERTIES(mysqlcppconn-static PROPERTIES
					LINK_FLAGS "${MYSQLCPPCONN_LINK_FLAGS_ENV} ${MYSQL_LINK_FLAGS}"
					COMPILE_FLAGS "${MYSQLCPPCONN_COMPILE_FLAGS_ENV} ${MYSQL_CXXFLAGS}"
					COMPILE_DEFINITIONS CPPCONN_LIB_BUILD="")


SET_TARGET_PROPERTIES(mysqlcppconn
					PROPERTIES
					SOVERSION "${MYSQLCPPCONN_SOVERSION}"
					VERSION "${MYSQLCPPCONN_SOVERSION}.${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
					LINK_FLAGS "${MYSQLCPPCONN_LINK_FLAGS_ENV} ${MYSQL_LINK_FLAGS}"
					COMPILE_FLAGS "${MYSQLCPPCONN_COMPILE_FLAGS_ENV} ${MYSQL_CXXFLAGS}"
					COMPILE_DEFINITIONS CPPCONN_SO_BUILD="")

IF(WIN32)
	INSTALL(TARGETS mysqlcppconn mysqlcppconn-static
		RUNTIME DESTINATION lib
		ARCHIVE DESTINATION lib
	)
ELSE(WIN32)
	INSTALL(TARGETS mysqlcppconn mysqlcppconn-static
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
	)
ENDIF(WIN32)


# Install some MySQL specific headers
SET(MYSQLCPPCONN_SPECIFIC_INSTALL_HEADERS
		mysql_connection.h
		mysql_driver.h)

INSTALL(FILES ${MYSQLCPPCONN_SPECIFIC_INSTALL_HEADERS} DESTINATION include)


MESSAGE(STATUS "Configuring driver")

=== debian/changelog ===
mysql-workbench (5.2.38+dfsg-3) unstable; urgency=low

  * native server administration profile (Closes: #667714 I:"Creating new
    server instance profile fails...")
  * patch to fix ifconfig invocation
  * d-rules:
    + better CPU number detection
    + build with all but 'bindnow' hardening

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Fri, 06 Apr 2012 23:00:35 +1000

mysql-workbench (5.2.38+dfsg-2) unstable; urgency=low

  * patch to fix FTBFS with glib 2.32
    (Closes: #665584 I:"individual glib headers no longer supported")
  * d-rules: get correct number of CPUs for parallel build on Linux
    (Closes: #665862 W:"Build process not is paralleled on some Linux
     architectures")

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Tue, 27 Mar 2012 21:57:45 +1100

mysql-workbench (5.2.38+dfsg-1) unstable; urgency=low

  * first Debian release (Closes: #604174 ITP)
    Thanks to David Paleino

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Thu, 01 Mar 2012 21:57:30 +1100

=== debian/control ===
Source: mysql-workbench
Section: database
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@member.fsf.org>
Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
Build-Depends: debhelper (>= 9), dh-autoreconf, perl, imagemagick,
 bison, flex, swig,
 doxygen,
 gettext,
 libboost-dev,
 libcairo2-dev,
 libctemplate-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglib2.0-dev, 
 libgnome-keyring-dev,
 libgtkmm-2.4-dev,
 liblua5.1-0-dev,
 libpng12-dev,
 libmysqlclient-dev,
 libpcre3-dev,
 libpixman-1-dev, 
 libsqlite3-dev,
 libtinyxml-dev,
 libxml2-dev,
 libzip-dev,
 python-all-dev,
 uuid-dev,
 xdg-utils,
# libmysqlcppconn-dev,
Standards-Version: 3.9.3
Homepage: http://dev.mysql.com/workbench/
VCS-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mysql-workbench.git
VCS-Git: git://anonscm.debian.org/collab-maint/mysql-workbench.git

Package: mysql-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 mysql-workbench-data (= ${source:Version}), mysql-client,
 python-mysql.connector, python-paramiko, python-pysqlite2, python-all, python-pexpect
Recommends: ttf-bitstream-vera, mysql-utilities,
Suggests: gnome-keyring
Description: MySQL Workbench - a visual database modeling, administration and queuing tool
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.

Package: mysql-workbench-data
Architecture: all
Depends: ${misc:Depends}
Description: MySQL Workbench -- architecture independent data
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.
 .
 This package provides architecture independent files

#Package: mysql-workbench-dbg
#Section: debug
#Priority: extra
#Architecture: any
#Depends: mysql-workbench (= ${binary:Version}), ${misc:Depends}
#Description: MySQL Workbench -- debugging symbols
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides debugging symbols

#Package: mysql-workbench-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: MySQL Workbench -- Documentation for developers
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides documentation for developers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PACKAGE := mysql-workbench

# parallel build by default on linux
ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
        export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
    endif
endif
$(info Info: DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-bindnow

%:
	dh $@ --parallel --with autoreconf,python2

override_dh_autoreconf:
	#NOCONFIGURE="1" ./autogen.sh
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib \
		--exec-prefix=/usr/lib/$(PACKAGE) \
		--enable-grt-generation \
		--enable-dependency-tracking
		#--with-commondirname

override_dh_auto_build:
	# rebuild files generated by swig
	$(MAKE) -C library/forms/swig --makefile Makefile.swig
	# rebuild files generated by flex/bison
	cd library/sql-parser/yy_gen-tool/yy_gen-tool/ \
	&& bison -dl parser.yy \
	&& flex -B -oparser.lex.cc parser.lex
	# generate icon
	convert images/icons/MySQLWorkbench-32.png debian/mysql-workbench.xpm
	# generate documentation for mysql-workbench-docs package
	#cd doc && ./DoxygenRun.sh
	# build all the rest
	dh_auto_build

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp
	# .desktop to unix line endings
	sed -i 's/\r//g' debian/tmp/usr/share/applications/*.desktop
	# remove *.la files
	find . -name '*.la' -delete -printf 'removing %p\n'
	# move plugins to "/usr/lib/mysql-workbench" where they can be found by M-W
	mv $(CURDIR)/debian/tmp/usr/lib/$(PACKAGE)/plugins/* \
           $(CURDIR)/debian/tmp/usr/lib/$(PACKAGE)/
	# wipe empty dirs if any
	find $(CURDIR)/debian/tmp -type d -empty -delete
	# install link to launcher to /usr/bin/
	dh_link -p$(PACKAGE) usr/lib/$(PACKAGE)/bin/mysql-workbench \
            usr/bin/mysql-workbench

override_dh_compress:
	dh_compress --exclude=.mwb

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# -dbg package will be over 150 MiB
#override_dh_strip:
#	dh_strip --dbg-package=$(PACKAGE)-dbg


COPHINTS := debian/copyright.hints
VER = $(shell dpkg-parsechangelog | perl -ne 'print $$1 if m/Version:\s*([\d\.]+)/')
get-orig-source: $(PACKAGE)-$(VER)
	@echo "Clean-up..."
	find $(PACKAGE)-$(VER) -type f -name '*.cmd' -delete -printf 'removing %p\n'
	find $(PACKAGE)-$(VER) -type f -name '*.vc*' -delete -printf 'removing %p\n'
	find $(PACKAGE)-$(VER) -depth -type d -name 'macosx' -exec $(RM) -r {} \; -printf 'removing %p\n'
	find $(PACKAGE)-$(VER) -depth -type d -name 'windows' -exec $(RM) -r {} \; -printf 'removing %p\n'
	cd $(PACKAGE)-$(VER) \
	&& $(RM) -r -v \
             build/msi \
             build/res \
             build/zip \
             ext/scintilla/cocoa \
             ext/scintilla/win32 \
             ext/cppconn/win \
             ext/connector-python \
             ext/ctemplate \
             ext/tinyxml \
             ext/python \
             ext/HTMLRenderer \
             ext/mysql-utilities \
             frontend/mac \
             library/base.windows \
             library/forms/cocoa \
             library/sql-parser/yy_purify-tool/dist/*.jar \
             MySQLWorkbench.xcodeproj \
             res/fonts \
             tools/utils_wrapper
	@echo "Packing and scanning for copyright changes..."
	tar cJf "$(PACKAGE)_$(VER)+dfsg.orig.tar.xz" "$(PACKAGE)-$(VER)" \
	&& cd $(PACKAGE)-$(VER) \
	&& licensecheck --recursive --copyright --check='.*' --ignore='\.(jpg|ico|icns|mwb|sqlite|png)\Z|^debian/' --lines="99999" * \
	| grep -v '\*No copyright\* UNKNOWN' > ../$(COPHINTS).new
	DIF=$$(diff -U0 $(COPHINTS) $(COPHINTS).new) \
	; [ "$$?" -eq 0 ] && $(RM) $(COPHINTS).new \
	|| echo "$${DIF}" | tee $(COPHINTS).diff
	$(RM) -r $(PACKAGE)-$(VER)

$(PACKAGE)-$(VER):
	uscan --noconf --verbose --force-download --rename --repack --destdir=. --download-version $(VER)
	mkdir $(PACKAGE)-$(VER) \
	&& tar xf $(PACKAGE)_$(VER).orig.tar.gz --directory $(PACKAGE)-$(VER) --strip-components 1 \
	|| $(RM) -r $(PACKAGE)-$(VER)
	#$(RM) $(PACKAGE)_$(VER).orig.tar.gz

=== debian/watch ===
# Run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\+dfsg// \
http://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools/%5Bpage=0%5D \
 (?:.*)?/mysql-workbench-gpl-([\d\.]+)-src\.tar\.(?:gz|bz2|xz)

## mysql-workbench 5.2.40+dfsg

=== debian/changelog ===
mysql-workbench (5.2.40+dfsg-2) unstable; urgency=medium

  * Build-Depends on libtinyxml-dev (>= 2.6.2)
    to avoid FTBFS with older versions (Closes: #675336)
  * new patch to fix freeze on application exit (Closes: #682691).
  * debian/watch update to reflect mirror changes.
  * debian/rules to gracefully handle stripping if -dbg
    package is (un-)commented in debian/control.
  * xz compression for binary packages.

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Wed, 10 Oct 2012 00:54:13 +1100

mysql-workbench (5.2.40+dfsg-1) unstable; urgency=low

  * New upstream release [May 2012]
  * source compression to .xz
  * dropped glib-single-include.patch (applied upstream).
  * dropped '©' characters from debian/copyright.
  * dropped copyright.hints file.
  * native server administration profile renamed to "Debian".
    (Closes: #671050)
  * dropped unnecessary 'python-all' from Depends (Closes: #674768)
  * limit parallel build to 4 due to FTBFS with 8 CPUs.

  [ Mateusz Kijowski ]
  * debian/copyright cleanup

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Thu, 17 May 2012 22:59:56 +1000

=== debian/control ===
--- 
+++ 
@@ -12,16 +12,16 @@
  libctemplate-dev,
  libfreetype6-dev,
  libgl1-mesa-dev,
- libglib2.0-dev, 
+ libglib2.0-dev,
  libgnome-keyring-dev,
  libgtkmm-2.4-dev,
  liblua5.1-0-dev,
  libpng12-dev,
  libmysqlclient-dev,
  libpcre3-dev,
- libpixman-1-dev, 
+ libpixman-1-dev,
  libsqlite3-dev,
- libtinyxml-dev,
+ libtinyxml-dev (>= 2.6.2),
  libxml2-dev,
  libzip-dev,
  python-all-dev,
@@ -37,7 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
  mysql-workbench-data (= ${source:Version}), mysql-client,
- python-mysql.connector, python-paramiko, python-pysqlite2, python-all, python-pexpect
+ python-mysql.connector, python-paramiko, python-pysqlite2, python-pexpect
 Recommends: ttf-bitstream-vera, mysql-utilities,
 Suggests: gnome-keyring
 Description: MySQL Workbench - a visual database modeling, administration and queuing tool

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-bindnow
 
 %:
-	dh $@ --parallel --with autoreconf,python2
+	dh $@ --parallel --max-parallel=4 --with autoreconf,python2
 
 override_dh_autoreconf:
 	#NOCONFIGURE="1" ./autogen.sh
@@ -41,10 +41,10 @@
 	# generate documentation for mysql-workbench-docs package
 	#cd doc && ./DoxygenRun.sh
 	# build all the rest
-	dh_auto_build
+	dh_auto_build --max-parallel=4
 
 override_dh_auto_install:
-	dh_auto_install --destdir=$(CURDIR)/debian/tmp
+	dh_auto_install --max-parallel=4 --destdir=$(CURDIR)/debian/tmp
 	# .desktop to unix line endings
 	sed -i 's/\r//g' debian/tmp/usr/share/applications/*.desktop
 	# remove *.la files
@@ -65,11 +65,15 @@
 	dh_makeshlibs --noscripts
 
 # -dbg package will be over 150 MiB
-#override_dh_strip:
-#	dh_strip --dbg-package=$(PACKAGE)-dbg
+# gracefully handle stripping if -dbg package (un-)commented in debian/control
+override_dh_strip:
+	[ -d "$(CURDIR)/debian/$(PACKAGE)-dbg" ] \
+        && dh_strip --dbg-package=$(PACKAGE)-dbg \
+        || dh_strip
 
+override_dh_builddeb:
+	dh_builddeb -- -Zxz
 
-COPHINTS := debian/copyright.hints
 VER = $(shell dpkg-parsechangelog | perl -ne 'print $$1 if m/Version:\s*([\d\.]+)/')
 get-orig-source: $(PACKAGE)-$(VER)
 	@echo "Clean-up..."
@@ -98,15 +102,9 @@
              MySQLWorkbench.xcodeproj \
              res/fonts \
              tools/utils_wrapper
-	@echo "Packing and scanning for copyright changes..."
+	@echo "Packing..."
 	tar cJf "$(PACKAGE)_$(VER)+dfsg.orig.tar.xz" "$(PACKAGE)-$(VER)" \
-	&& cd $(PACKAGE)-$(VER) \
-	&& licensecheck --recursive --copyright --check='.*' --ignore='\.(jpg|ico|icns|mwb|sqlite|png)\Z|^debian/' --lines="99999" * \
-	| grep -v '\*No copyright\* UNKNOWN' > ../$(COPHINTS).new
-	DIF=$$(diff -U0 $(COPHINTS) $(COPHINTS).new) \
-	; [ "$$?" -eq 0 ] && $(RM) $(COPHINTS).new \
-	|| echo "$${DIF}" | tee $(COPHINTS).diff
-	$(RM) -r $(PACKAGE)-$(VER)
+	&& $(RM) -r $(PACKAGE)-$(VER)
 
 $(PACKAGE)-$(VER):
 	uscan --noconf --verbose --force-download --rename --repack --destdir=. --download-version $(VER)

=== debian/watch ===
# Run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\+dfsg// \
http://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools\
/mysql-workbench-gpl-([\d\.]+)-src\.tar\.(?:gz|bz2|xz)

## mysql-workbench 5.2.47+dfsg

=== debian/changelog ===
mysql-workbench (5.2.47+dfsg-1) unstable; urgency=low

  * Upload to unstable.
  * New patch to get libpython flags using `python-config`
    (Closes: #710627).
  * Build-Depends:
    - python-all-dev
    + python-dev (provides `python-config`)
    - libboost-dev
    + libboost1.53-dev | libboost-dev (needed to avoid FTBFS since
      libmysqlcppconn depends on boost1.53 which conflicts with older
      boost that is pulled by libboost-dev).
  * rules: added "-v" to `mv` command (more build-time verbosity).
  * rules: get-orig-source improvements.
  * Dropped unused lintian-overrides

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 05 Jun 2013 09:13:55 +1000

mysql-workbench (5.2.47+dfsg-1~exp0) experimental; urgency=low

  * New upstream release [February 2013].
  * Depends on "python-pyodbc (>= 2.1.8)" that is needed for ODBC
    database migration to MySQL. Thanks, Laurent Bigonville
    (Closes: #698969).
  * Build-Depends: libpng12-dev --> libpng-dev (transition).
  * Standards to 3.9.4.
  * Updated my email address.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 30 Mar 2013 01:10:38 +1100

mysql-workbench (5.2.45+dfsg-1~exp0) experimental; urgency=low

  * New upstream release [December 2012].
  * Added lintian-override for "broken symlink" to "libmysqlcppconn.so.6".

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Sun, 06 Jan 2013 13:41:56 +1100

mysql-workbench (5.2.44+dfsg-1~exp1) experimental; urgency=low

  * Build with "unixodbc" instead of "iodbc" (Closes: #690327).

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Sat, 13 Oct 2012 10:11:06 +1100

mysql-workbench (5.2.44+dfsg-1~exp0) experimental; urgency=low

  * New upstream release [September 2012]
  * Build without PIE hardening to avoid crash on autocompletion
    (Closes: #689497).
  * d/rules to make -dbg package if uncommented in d/control.

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Wed, 03 Oct 2012 21:08:50 +1000

mysql-workbench (5.2.43+dfsg-1~exp0) experimental; urgency=low

  * New upstream release [September 2012]
    (Closes: #682691) "Freeze on quit application".
  * Build-Depends:
    + added "libiodbc2-dev".
    + added "libtinyxml-dev (>= 2.6.2)"
      to avoid FTBFS with older versions (Closes: #675336).
    + added "libmysqlcppconn-dev (>= 1.1.1)"
      thanks to availability of new libmysqlcppconn
      the bundled version is no longer used.
  * debian/watch is updated to reflect mirror changes.
  * xz compression for binary packages.
  * lintian-overrides for hardening false-positives.
  * added TODO.Debian: unbundle antlr when possible.
  * added README.Debian with note about outdated ChangeLog.
  * dropped obsolete patches [automake-1.11.2,disable_scintillaNET]
  * updated remaining patches for new release.
  * debian/rules:
    + get-orig-source to remove cppconn from dfsg-repackaged archive.
    + --as-needed to minimise needless linking (backport-friendly).
  * updated man page: argument list refreshed and alphabetised.

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Thu, 31 May 2012 23:49:30 +1000

=== debian/control ===
--- 
+++ 
@@ -1,44 +1,51 @@
 Source: mysql-workbench
 Section: database
 Priority: optional
-Maintainer: Dmitry Smirnov <onlyjob@member.fsf.org>
+Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
-Build-Depends: debhelper (>= 9), dh-autoreconf, perl, imagemagick,
- bison, flex, swig,
- doxygen,
- gettext,
- libboost-dev,
- libcairo2-dev,
- libctemplate-dev,
- libfreetype6-dev,
- libgl1-mesa-dev,
- libglib2.0-dev,
- libgnome-keyring-dev,
- libgtkmm-2.4-dev,
- liblua5.1-0-dev,
- libpng12-dev,
- libmysqlclient-dev,
- libpcre3-dev,
- libpixman-1-dev,
- libsqlite3-dev,
- libtinyxml-dev (>= 2.6.2),
- libxml2-dev,
- libzip-dev,
- python-all-dev,
- uuid-dev,
- xdg-utils,
-# libmysqlcppconn-dev,
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), dh-autoreconf, perl, imagemagick
+ ,bison ,flex ,swig
+ ,doxygen
+ ,gettext
+# ,libantlr3c-dev
+ ,libboost1.53-dev | libboost-dev
+ ,libcairo2-dev
+ ,libctemplate-dev
+ ,libfreetype6-dev
+ ,libgl1-mesa-dev
+ ,libglib2.0-dev
+ ,libgnome-keyring-dev
+ ,libgtkmm-2.4-dev
+ ,liblua5.1-0-dev
+ ,libmysqlcppconn-dev (>= 1.1.1)
+ ,libpng-dev
+ ,libmysqlclient-dev
+ ,libpcre3-dev
+ ,libpixman-1-dev
+ ,libsqlite3-dev
+ ,libtinyxml-dev (>= 2.6.2)
+ ,libxml2-dev
+ ,libzip-dev
+ ,python-dev
+ ,unixodbc-dev
+ ,uuid-dev
+ ,xdg-utils
+Standards-Version: 3.9.4
 Homepage: http://dev.mysql.com/workbench/
-VCS-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mysql-workbench.git
-VCS-Git: git://anonscm.debian.org/collab-maint/mysql-workbench.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mysql-workbench.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/mysql-workbench.git
 
 Package: mysql-workbench
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
- mysql-workbench-data (= ${source:Version}), mysql-client,
- python-mysql.connector, python-paramiko, python-pysqlite2, python-pexpect
-Recommends: ttf-bitstream-vera, mysql-utilities,
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
+ ,mysql-workbench-data (= ${source:Version})
+ ,mysql-client
+ ,python-mysql.connector
+ ,python-paramiko
+ ,python-pexpect
+ ,python-pyodbc (>= 2.1.8)
+ ,python-pysqlite2
+Recommends: ttf-bitstream-vera, mysql-utilities
 Suggests: gnome-keyring
 Description: MySQL Workbench - a visual database modeling, administration and queuing tool
  MySQL Workbench is a modeling tool that allow to design

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

# parallel build by default on linux
ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
        export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
    endif
endif
$(info Info: DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed

%:
	dh $@ --parallel --max-parallel=4 --with autoreconf,python2

# use --as-needed only if supported by dh-autoreconf (to simplify backporting)
DH_AS_NEEDED=$(shell dpkg --compare-versions $$(dpkg --status dh-autoreconf | grep Version | cut -d' ' -f2) ge 6 && echo --as-needed)
override_dh_autoreconf:
	#NOCONFIGURE="1" ./autogen.sh
	dh_autoreconf $(DH_AS_NEEDED)

override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib \
            --libexecdir=/usr/lib/$(PKG)/bin \
            --exec-prefix=/usr/lib/$(PKG) \
            --enable-grt-generation \
            --enable-dependency-tracking \
            --with-unixodbc \
                --with-odbc-cflags=-I/usr/include \
                --with-odbc-libs=-lodbc
	#--with-commondirname

override_dh_auto_build:
	# rebuild files generated by swig
	$(MAKE) -C library/forms/swig --makefile Makefile.swig
	# rebuild files generated by flex/bison
	cd library/sql-parser/yy_gen-tool/yy_gen-tool/ \
        && bison -dl parser.yy \
        && flex -B -oparser.lex.cc parser.lex
	# generate icon
	convert images/icons/MySQLWorkbench-32.png debian/mysql-workbench.xpm
	# generate documentation for mysql-workbench-docs package
	#cd doc && ./DoxygenRun.sh
	# build all the rest
	dh_auto_build --max-parallel=4

override_dh_auto_install:
	dh_auto_install --max-parallel=4 --destdir=$(CURDIR)/debian/tmp
	# .desktop to unix line endings
	sed -i 's/\r//g' debian/tmp/usr/share/applications/*.desktop
	# remove *.la files
	find . -name '*.la' -delete -printf 'removing %p\n'
	# move plugins to "/usr/lib/mysql-workbench" where they can be found by M-W
	mv -v $(CURDIR)/debian/tmp/usr/lib/$(PKG)/plugins/* \
              $(CURDIR)/debian/tmp/usr/lib/$(PKG)/
	# wipe empty dirs if any
	find $(CURDIR)/debian/tmp -type d -empty -delete
	# install link to launcher to /usr/bin/
	dh_link -p$(PKG) usr/lib/$(PKG)/bin/mysql-workbench \
            usr/bin/mysql-workbench

override_dh_compress:
	dh_compress --exclude=.mwb

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# -dbg package will be over 150 MiB
override_dh_strip:
	[ -d "$(CURDIR)/debian/$(PKG)-dbg" ] \
        && dh_strip --dbg-package=$(PKG)-dbg \
        || dh_strip

override_dh_builddeb:
	dh_builddeb -- -Zxz

VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{Version:\s*([\d\.]+)}')
DTYPE := +dfsg
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(PKG)-$(VER)
	@echo "Clean-up..."
	find $(PKG)-$(VER) -type f -name '*.cmd' -delete -printf 'removing %p\n'
	find $(PKG)-$(VER) -type f -name '*.vc*' -delete -printf 'removing %p\n'
	find $(PKG)-$(VER) -depth -type d -name 'macosx' -exec $(RM) -r {} \; -printf 'removing %p\n'
	find $(PKG)-$(VER) -depth -type d -name 'windows' -exec $(RM) -r {} \; -printf 'removing %p\n'
	cd $(PKG)-$(VER) \
        && $(RM) -r -v \
             build/msi \
             build/res \
             build/zip \
             ext/Aga.Controls \
        0000-ext/antlr-runtime \
             ext/scintilla/cocoa \
             ext/scintilla/win32 \
             ext/cppconn \
             ext/connector-python \
             ext/ctemplate \
             ext/tinyxml \
             ext/python \
             ext/HTMLRenderer \
             ext/mysql-utilities \
             frontend/mac \
             library/base.windows \
             library/forms/cocoa \
             library/sql-parser/yy_purify-tool/dist/*.jar \
             MySQLWorkbench.xcodeproj \
             res/fonts \
             tools/utils_wrapper
	@echo "Packing..."
	XZ_OPT="-7v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" "$(PKG)-$(VER)" --owner=root --group=root --mode=a+rX \
        && $(RM) -r $(PKG)-$(VER)

$(PKG)-$(VER):
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --repack --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	mkdir $(PKG)-$(VER) \
        && tar -xf $(PKG)_$(VER).orig.tar.gz --directory $(PKG)-$(VER) --strip-components 1 \
        || $(RM) -r $(PKG)-$(VER)
	#$(RM) $(PKG)_$(VER).orig.tar.gz

=== debian/watch ===
# uscan(1) configuration file.
# Use 'debian/rules get-orig-source' command to generate DFSG-repackaged archive.

version=3

opts=dversionmangle=s/\+dfsg// \
http://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools\
/mysql-workbench-gpl-([\d\.]+)-src\.tar\.(?:gz|bz2|xz)
